<script lang="ts">
	import { onMount } from 'svelte';
	import { base } from '$app/paths';
	import { load } from '$lib/machinery/loader-store.js';
	import { getUnspentOutputs } from '@unspent/psi';

	import ImageList, { Item, Image, Supporting, Label } from '@smui/image-list';
	import { chaingraphHost } from '$lib/store.js';
	import {
		instantiateSha256,
		hexToBin,
		lockingBytecodeToCashAddress,
		lockingBytecodeToBase58Address
	} from '@bitauth/libauth';
	import { browser } from '$app/environment';
	import { workerData } from 'worker_threads';

	export let lockingBytecode;
	let results;
	let cashaddr = '';
	let bytecodeDetails;
	let legacy = '';
	let chaingraphHostValue = '';

	chaingraphHost.subscribe((value) => {
		chaingraphHostValue = value;
	});

	onMount(async () => {
		if (chaingraphHostValue.length > 0) {
			loadTx();
		}
	});

	function getUnevenImageSize(
		counter: number,
		base: number,
		variance: number,
		preAdd = (num: number) => num
	) {
		const mid = (counter % 2 ? Math.cos : Math.sin)(counter) * variance;
		return base + Math.floor(preAdd(mid));
	}

	const loadTx = async () => {
		await load({
			load: async () => {
				const sha256Promise = instantiateSha256();
				results = (await getUnspentOutputs(chaingraphHostValue, lockingBytecode)).search_output_prefix;
				results = results.map((r) => {
					return {
						txid: r.transaction_hash.slice(2),
						vout: r.output_index,
						satoshis: r.value_satoshis
					};
				}).reverse();
				let cashaddrResponse = lockingBytecodeToCashAddress(
					hexToBin(lockingBytecode),
					'bitcoincash'
				);
				if (typeof cashaddrResponse === 'string') cashaddr = cashaddrResponse;
				const sha256 = await sha256Promise;
				let legacyResponse = lockingBytecodeToBase58Address(
					sha256,
					hexToBin(lockingBytecode),
					'mainnet'
				);
				if (typeof legacyResponse === 'string') legacy = legacyResponse;
			}
		});
	};
</script>



{#if lockingBytecode}
<p style="line-break: anywhere;">{lockingBytecode}</p>
	{#if results}
		<ImageList class="my-image-list-masonry" style="min-height:500px;"  masonry>
			{#each results as txo}
				<Item>
					<div class="tract" style="height:{getUnevenImageSize(txo.satoshis, 60, 180, Math.abs)}px">
						<h2>⚫ {new Intl.NumberFormat().format(txo.satoshis) }</h2>
						<a target=_blank href="https://explorer.bitcoinunlimited.info/tx/{txo.txid}" >Transaction</a>
					</div>
				</Item>
			{/each}
		</ImageList>
	{/if}
{/if}

<style>
	.tract {
		align-items: center;
		background: rgb(231, 231, 231);
		border-radius: 30px;
		padding: 10px;
	}
	.tract h2 {
		font-weight: 600;
    font-size: medium;
		color: rgb(90, 55, 5);
	}
  .tract a {
		font-weight: 400;
		color: rgb(48, 28, 0);
    
	}

</style>